function W = Wbm(u,v);
%Wavelet basis matrix 
%
% W = Wbm(u,v);
%
% u,v - mather,father wavelets
% W   - E->B change of basis matrix
%       (columns of inv(W)=conj(W') are wavelet basis vectors )       
%
%  [z]_B = W*z  
%

if size(u,1)~=1,
   u=u';
   v=v';
end


N = length(u); %M

W=[];
for i=1:2:N %v
   W(:,end+1)=Rk(i-1,v)';
end
for i=1:2:N %u
   W(:,end+1)=Rk(i-1,u)';
end;
%B->E

%E->B
W = conj(W'); %= inv(W)
