function [W]=Wbm_p(p, u,v)
%pth stage wavelet basis matrix 
%
% W = Wbm_p(u,v);
%
% u,v - mather,father wavelets
% W   - E->B change of basis matrix
%       (columns of inv(W)=conj(W') are wavelet basis vectors )       
%
%  [z]_B = W*z  
%

N=length(u);
[F,G]=get_fg(p, u,v);

W=[];

for l=1:p,
   for k=0:N/(2^l)-1
      psi = psi_phi_jk(F(:,l), l,k);
      W(:,end+1)=psi;
   end
end
for k=0:N/(2^p)-1
      phi = psi_phi_jk(G(:,l), l,k);
      W(:,end+1)=phi;
end
%B->E

%E->B
W = conj(W'); %= inv(W)
