%demo 

N=512;

n=0:N-1;
s1 = sin(abs(n-128).^1.7/128);
s1 = s1(129:256);

s2 = sin(abs(n-128).^2/128);
s2 = s2(385:448);

z = [zeros(1,128), s1, zeros(1,128), s2, zeros(1,64)];

o=figure(1),plot(z);
xlim([0,511])
title('z');
set(o,'name','z');
grid on

p=4
[u,v] = Shanon(N); %mother, father wavelets
%
W=Wbm_p(p, u,v); %p-th stage wavelet transformation
z_=W*z';
%        
%   (equivalent with:)
%   
%z_ =Wt_p(z, u,v,p)

%figure(2), plot(z_);

tmp = z_;
for i=1:p
   zz_ = tmp(1:N/(2^i));
   tmp(1:N/(2^i))=[];
   
   uzz_ = Ul(i,zz_);
   
   o=figure(1+i),
   plot(n(~(uzz_==0)),uzz_(~(uzz_==0)),'b+'),
   title(sprintf('<z, psi_{-%d,k}>',i));
   xlim([0,511])
   set(o,'name',sprintf('z_ps%d',i));
   grid on
end

uzz_=Ul(p,tmp);
o=figure(1+p+1),
plot(n(~(uzz_==0)),uzz_(~(uzz_==0)),'b+'),
title(sprintf('<z, phi_{-%d,k}>',p));
xlim([0,511])
set(o,'name',sprintf('z_pf%d',i));
grid on

% ---------
s=0;
for i=1:p+1,
   o=figure,
   
   r = s + N/(2^(i+1));
   if i==p+1,
      r = s + N/(2^(i));
	end
   
   s = s + N/2^i;
   
   subplot(121)
   plot(real(W(r,:))); xlim([0,511])
   title(sprintf('psi_{-%d}',i));
   if i==p+1,
         title(sprintf('phi_{-%d}',i-1));
   end
   grid on
   
   
   subplot(122)
   plot(abs(fft(W(r,:))')); xlim([0,511])
   title(sprintf('DFT(psi_{-%d})',i));
   if i==p+1,
         title(sprintf('DFT(phi_{-%d})',i-1));
   end
   grid on
   
	set(o,'name',sprintf('w%d',i));
end

   

