%%
% demo2
%
% partial reconstruction
%
%%

N=512;

n=0:N-1;
s1 = sin(abs(n-128).^1.7/128);
s1 = s1(129:256);

s2 = sin(abs(n-128).^2/128);
s2 = s2(385:448);

z = [zeros(1,128), s1, zeros(1,128), s2, zeros(1,64)];

figure(1),plot(z);
xlim([0,511])


p=4
[u,v] = Shanon(N); %mother, father wavelets
%
W=Wbm_p(p, u,v); %p-th stage wavelet transformation
z_=W*z';

%reconstruction 
%
W_inv = conj(W'); %W_inv = inv(W);
%
tmp = z_;
tmp(1:N-N/2^p)=zeros(size(1,N/2^p));
P4 = W_inv*tmp;
o=figure(2), plot(real(P4)); title('P_{-4}(z)');
set(o,'name','P-4');
xlim([0,511])

tmp = z_;
tmp(1:N-2*N/2^p)=zeros(size(1:N-2*N/2^p));
P3 = W_inv*tmp;
o=figure(3), plot(real(P3)); title('P_{-3}(z)');
set(o,'name','P-3');
xlim([0,511])

tmp = z_;
tmp(1:N-2*N/2^p-N/(2^(p-1)))=zeros(size(1:N-2*N/2^p-N/(2^(p-1))));
P2 = W_inv*tmp;
o=figure(4), plot(real(P2)); title('P_{-2}(z)');
set(o,'name','P-2');
xlim([0,511])

tmp = z_;
tmp(1:N-2*N/2^p-N/(2^(p-1))-N/(2^(p-2)))=zeros(size(1:N-2*N/2^p-N/(2^(p-1))-N/(2^(p-2))));
P1 = W_inv*tmp;
o=figure(5), plot(real(P1)); title('P_{-1}(z)');
set(o,'name','P-1');
xlim([0,511])

tmp = z_;
P0 = W_inv*tmp;
o=figure(6), plot(real(P0)); title('P_{0}(z)');
set(o,'name','P-0');
xlim([0,511])

o=figure(7); 
plot(z'-real(P0),'r'); title('z - P_{0}(z) (full reconstruction error)')
set(o,'name','err');
xlim([0,511])
