function [z] = iwt(z_, u,v)
%IWT: inverse wavelet transformation
%
% [z] = iwt(z_, u,v) 
%
% u,v  - mather,father wavelets
% z_   - input signal
%
% z  - transformed signal
%

N = length(z_);

vv = U2(z_(1:N/2));
uu = U2(z_(N/2+1:N));

t = idft(dft(conj(v)));
s = idft(dft(conj(u)));

z = convolf(t,vv)+convolf(s,uu);

